/* UNH CS 758 assignment 10

   header file with shared types and declarations

   Wheeler Ruml, October 2024
*/

#include <stdio.h>
#include <stdlib.h>  /* free, EXIT_SUCCESS */


/**************** types ***********************/


/* the graph is static, we only need outarcs.  vertices are numbered
 from 1. */
  
typedef struct arc {
  unsigned int dest;
  float cost;
} arc;

typedef struct graph {
  /* not including dummy vertex 0 */
  unsigned int num_vertices;
  /* arcs_end[i] = index just after vertex i's last arc.
     arcs_end[0] = 0 */
  unsigned int *arcs_end;
  arc *arcs;
} graph;


typedef struct path {
  unsigned int len;
  unsigned int *vertices;
} path;


typedef path *(solver)(const graph *g, const unsigned int start, const unsigned int goal);


/********* functions used outside the file they are defined in *********/


/* defined in main.c */
path *alloc_path(unsigned int len);
void path_copy(path *dest, path *src);
void free_path(path *p);
/* defined in dfs.c */
solver dfs_first;
solver dfs_shortest;
/* defined in dijkstra.c */
solver dijkstra;


/* EOF */
